/*
FileName:UserModifyProject.js
Version:1.0.0
Purpose:Modify the existing Project
Devloper:Mahesh
*/
import React, { Component } from 'react';
import Requesteddata from '../AdminComponets/AdminRequestedDataProjects';
import { Platform, StyleSheet, Text, View, Dimensions, FlatList, TouchableHighlight, Image, TouchableOpacity, TextInput, Alert, Keyboard, KeyboardAvoidingView, TouchableWithoutFeedback } from 'react-native';
import { Left, Button, Container, Header, Content, Item, Input } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import Toast from 'react-native-whc-toast';
import log from '../LogFile/Log';
import { ADDMODULE, MODULE_TITLE } from '../CommonComponents/Header';
import DatePicker from 'react-native-datepicker';
import MultiSelect from 'react-native-multiple-select';
export default class AdminGroupChatModify extends React.Component {

    constructor(props) {
        super(props);
        this.state = {
            open: false,
            modulename: '',
            id: this.props.navigation.state.params.id,
            role: '',
            userToken: '',
            modalVisible: false,
            // action: this.props.navigation.state.params.action,//getting action
            group_name: this.props.navigation.state.params.group_name,//idea id
            members_name: this.props.navigation.state.params.members_name,//moduledesc
            resource1: this.props.navigation.state.params.members_email,

            error1: '',
            error2: '',
            // resource1: [],
            itemPressedDisabled: false,
            selectedItems: [],
        };

    }
    onSelectedItemsChange = selectedItems => {
        this.setState({ selectedItems });
        
      };
    //Open the Dialog Modal
    modalDidOpen = () => console.log("Modal did open.");
    //close the Dialog Modal
    modalDidClose = () => {
        this.props.navigation.goBack();
        this.setState({ open: false }); this.setState({ open: false });
        console.log("Modal did close.");

    };

    //Dialog actions start
    moveUp = () => this.setState({ offset: -100 });

    resetPosition = () => {
        this.setState({ offset: 0 });
        this.props.navigation.goBack();
    }

    //open the dialog 
    openModal = () => {
        this.setState({ open: true })

    };
    //close the dialog
    closeModal = () => {
        this.setState({ open: false });
        this.props.navigation.goBack();
    }
    //Dialog actions end
    componentDidMount() {
        log("Debug", "Module Add screen is loaded");
        this.openModal();
        this.getEmployees();

        // this.setModalVisible(!this.state.modalVisible);
    }


  //getting the Employees list for addind maintask
  getEmployees() {
    log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");
    const { ModuleId } = this.state;
    const { ideaid } = this.state;
    // console.warn("ModuleId"+ModuleId)
    AsyncStorage.getItem("projectId", (err, res) => {
      const projectId = res;

      AsyncStorage.getItem("cropcode", (err, res) => {
        const cropcode = res;
         AsyncStorage.getItem("emp_role", (err, res) => {
        const emp_role = res;
         AsyncStorage.getItem("userToken", (err, res) => {
        const userToken = res;
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {
            fetch(API + 'agile_squads.php',
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  crop: cropcode,
                  userType: emp_role,
                  empId:userToken,

                })
              })
              .then((response) => response.json())
              .then((responseJson) => {
                // alert(JSON.stringify(responseJson))
                if (responseJson.status === 'True') {

                  var empList = [];
                  responseJson.data.map((employee) => {
                    return (
                      empList.push({
                        'id': employee.email, 'name': employee.name
                      })
                    );
                  })

                  this.setState({
                    resource1: empList,
                  });
                }
              })
              .catch((error) => {
                console.error(error);
                log("Error", "requested projects error");
              });
          }
        });
      });
        });
      });
    });
  }



    //Refresh data
    onRefresh() {
        this.setState({ isFetching: true }, function () { this.add() });
    }

 
  isValid() {
    const { group_name } = this.state;
    const { selectedItems } = this.state;
    let valid = false;

    if (group_name.length === 0) {
      this.setState({ error1: 'Enter Group Name ' });
      log("Warn", "project title should not be empty");
      // alert("project title should not be empty ");

    }

    else if (selectedItems.length === 0) {
      this.setState({ error2: 'Select the Group Members ' });
      log("Warn", "project description should not be empty");
      // alert("project description should not be empty");
    }

    else {
      valid = true;
    }
    return valid;
  }//isValid method end

  verifyProjectTitle(ProjectTitle) {
    var reg = /^[^!-\\/:-@\\[-`{-~]+$/;
    return reg.test(ProjectTitle);
  }

  //to add the new project from user 
  addGroup = () => {
    log("Info", "addGroup() method is used to add new project at user side");
    // alert(this.state.id)
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == "unknown" || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
      }
      else {
        const { group_name, } = this.state;
        if (this.isValid()) {
          // alert(group_name)
          // alert(this.state.selectedItems)

          this.setState({ itemPressedDisabled: true })
          AsyncStorage.multiGet(["cropcode", "userName", "fullName"], (err, response) => {
            const cropcode = response[0][1];
            const userName = response[1][1];
            // console.warn("userToken" + userToken)
            const fullName = response[2][1];
            AsyncStorage.getItem("projectId", (err, res) => {
              const projectId = res;
              fetch(API + 'group_chat.php', {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  group_name: group_name,
                  mobileLabel: this.state.selectedItems,
                  created_by: userName, //Async
                  created_by_name:fullName,
                  action: "mobileEditGroup",
                  crop: cropcode,//Async
                     group_Id: this.state.id,
                  // members: this.state.selectedItems.toString(),
                  projectId: projectId
                })
              }).then((response) => response.json())
                .then((responseJson) => {
                  console.log(JSON.stringify(responseJson));
                  console.log(responseJson);
                  // alert(JSON.stringify(responseJson))

                  if (responseJson.status === 'True') {
                    alert(responseJson.message)
                    this.refs.toast.showBottom('Group Modified Succesfully');
                    this.setState({ itemPressedDisabled: false })
                    console.log("done")
                    this.setState({
                      open: false,
                      group_name: '',
                      selectedItems: '',
                    })
                    this.getGroupDetails()

                  }
                }).catch((error) => {
                  console.error(error);
                  log("Error", "error in project adding");
                });
            });
          });
          this.closeModal();
        }
      }

    });


  };



    //Modify the existing module
    modifyProject() {
        log("Info", " modifyProject(moduledesc, idea_id, cropcode) is used Modify the existing module");
        const { idea_description, idea_title } = this.state;
        const { idea_id } = this.state;
        // alert(idea_description)
        console.log("idea_id" + idea_id);


        //userToken and crop code getting
        AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            console.log("userToken" + userToken);
            console.log("cropcode" + cropcode);
            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;
                //Checking the Network connection
                NetInfo.fetch().then(state => {
                    if (state.type == "none") {
                        console.log(state.type);
                        log("Warn", "No internet connection");
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    } else {
                        if (this.isValid()) {
                            this.setState({ itemPressedDisabled: true })
                            fetch(API + 'manage_epics.php',
                                {
                                    method: 'POST',
                                    headers: {
                                        Accept: 'application/json',
                                        'Content-Type': 'application/json',
                                    },
                                    body: JSON.stringify({
                                        action: this.state.action,
                                        idea_id: idea_id,
                                        corp: cropcode,
                                        proj_title: idea_title,
                                        proj_desc: idea_description,
                                        projectId: projectId,
                                        // moduleId: this.state.moduleId,

                                        empId: userToken

                                    })
                                })
                                .then((response) => response.json())
                                .then((responseJson) => {
                                    console.log(responseJson)
                                    // alert(JSON.stringify(responseJson))

                                    if (responseJson.status == 'True') {
                                        this.setState({ open: false });
                                        this.setState({ itemPressedDisabled: false })
                                        Snackbar.show({
                                            title: 'Epic Modified',
                                            backgroundColor: 'green',
                                            duration: Snackbar.LENGTH_LONG,
                                        });
                                        this.props.navigation.navigate("Aproved");
                                        //Navigate to AddModule screen
                                        // this.props.navigation.navigate("Aproved", { idea_id: this.state.idea_id });
                                    }
                                    // this.refs.toast.show('Project Modified', Toast.Duration.long, Toast.Position.center);

                                })
                                .catch((error) => {
                                    console.error(error);
                                    log("Error", "Modify the existing module error");
                                });
                        }
                    }
                });
            });
        });

    }

    render() {
        const { modalVisible, selectedItems } = this.state;

        return (
            <KeyboardAvoidingView
                behavior={Platform.OS === "ios" ? "padding" : "height"}
                style={styles.MainContainer}
                keyboardVerticalOffset={100}
            >
                <TouchableWithoutFeedback onPress={Keyboard.dismiss}>

                    <Modal
                        offset={this.state.offset}
                        closeOnTouchOutside={false}
                        open={this.state.open}
                        modalDidOpen={this.modalDidOpen}
                        modalDidClose={this.modalDidClose}
                        style={{ alignItems: "center" }} >

                        {/* <View style={{ alignItems: "center", paddingBottom: 20 }}> */}
                            <Toast ref="toast" />

                            <View style={{ alignItems: "center", }}>

                                <Text>Edit Group</Text>

                                <TextInput placeholder='Group Name'
                                    style={{ height: 40, borderBottomWidth: 1, borderBottomColor: 'black', width: 300, marginTop: 10 }}
                                    maxLength={50}
                                    onChangeText={(text) => this.setState({ group_name: text })}
                                    value={this.state.group_name} />
                                <Text style={{ color: 'red', alignItems: 'flex-start', alignSelf: 'flex-start', justifyContent: 'flex-start', marginLeft: 25 }}>{this.state.error1}</Text>
                                <Text style={{ color: 'red', alignItems: 'flex-start', alignSelf: 'flex-start', justifyContent: 'flex-start', marginLeft: 25 }}>{this.state.error3}</Text>




                                <View style={{ width: '90%', marginTop: 10 }}>
                                    <MultiSelect
                                        hideTags
                                        items={this.state.resource1}
                                        style={{ width: '90%' }}
                                        uniqueKey="id"
                                        ref={(component) => { this.multiSelect = component }}
                                        onSelectedItemsChange={this.onSelectedItemsChange}
                                        // onSelectedItemsChange={this.onSelectedItemsChange({members:item.id,label:item.name})}
                                        // onItemSelect={(item) => this.setState({ assignedto: item.id })}
                                        selectedItems={selectedItems}
                                        styleItemsContainer={{height:150}}
                                        selectText={this.state.members_name}
                                        searchInputPlaceholderText="Search Items..."
                                        onChangeInput={(text) => console.log(text)}
                                        // altFontFamily="ProximaNova-Light"
                                        tagRemoveIconColor="#CCC"
                                        tagBorderColor="#CCC"
                                        tagTextColor="#CCC"
                                        selectedItemTextColor="#CCC"
                                        selectedItemIconColor="#CCC"
                                        itemTextColor="#000"
                                        displayKey="name"
                                        searchInputStyle={{ color: '#CCC' }}
                                        submitButtonColor="#CCC"
                                        submitButtonText="Select"
                                    />
                                </View>

                            </View>
                            <View style={{ flexDirection: 'row', marginBottom: 20, alignItems: 'center', justifyContent: 'center', alignSelf: 'center', }}>

                                <TouchableOpacity style={styles.opensave} onPress={this.addGroup} disabled={this.state.itemPressedDisabled}>
                                    <Text style={{ color: 'white' }}>SAVE</Text>

                                </TouchableOpacity>
                                <TouchableOpacity style={styles.opencancel} onPress={this.closeModal}>
                                    <Text style={{ color: 'white' }}>CANCEL</Text>
                                </TouchableOpacity>

                            </View>
                        {/* </View> */}

                    </Modal>

                </TouchableWithoutFeedback>
            </KeyboardAvoidingView>
        );

    }

}
//Styles for UI
const styles = StyleSheet.create(
    {
        MainContainer:
        {
            flex: 1,
            width: Dimensions.get('window').width,
            height: Dimensions.get('window').height
        },
        bottomView: {
            flexDirection: 'row',
            justifyContent: 'center',
            position: 'absolute',
            height: FOOTER_MAX_HEIGHT,
            bottom: 0,
            left: 0,
            right: 0,
            backgroundColor: 'black',
            alignItems: 'center'
        },

        textStyle: {
            color: '#fff',
            fontSize: 18
        },
        container: {
            flex: 1,
            width: '90%',
            paddingLeft: hp('2%'),
        },
        footer: {
            position: 'absolute',
            flex: 0.1,
            left: 0,
            right: 0,
            bottom: -10,
            backgroundColor: 'green',
            flexDirection: 'row',
            height: 80,
            alignItems: 'center',
        },
        bottomButtons: {
            alignItems: 'center',
            justifyContent: 'center',
            flex: 1,
        },
        footerText: {
            color: 'white',
            fontWeight: 'bold',
            alignItems: 'center',
            fontSize: 18,
        },
        buttonContainer: {
            width: wp('90%'),
            alignSelf: 'baseline',
            marginBottom: 25,
            color: '#d2691e',
            marginLeft: 4,



        },
        signupButton: {

            backgroundColor: '#ffffff',
        },
        subcontainer: {
            flex: 2,
            flexDirection: 'row',
            paddingTop: 40
        },
        signUpText0: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

        },
        signUpText1: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

            paddingLeft: 10,
        },
        end: {

            alignItems: 'flex-end',

        },
        end1: {
            flex: 2,
            height: '50%',
            paddingTop: 20,
            justifyContent: 'space-between',

            flexDirection: 'row',
        },
        s: {
            justifyContent: 'center',

            backgroundColor: '#ed7070',
            shadowOffset: { width: 50, height: 50 },
            alignItems: 'center',
            width: wp('40%'),
            height: hp('12%'),

        },
        signUpText2: {
            fontSize: 10,
            marginLeft: 200,
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

            //  marginRight: 10,
            //textAlign: "right"

        },
        signUpText3: {

            fontSize: 12,
            paddingTop: 10,
            paddingLeft: 10,

            alignItems: 'center',
        },
        signUpText4: {
            fontSize: 12,
            paddingTop: 10,


            alignItems: 'center',
        },
        signup: {
            //paddingTop:20,
            color: "#FFF",

        },
        boxone: {
            flex: 1,
            marginTop: 5,

        },
        boxtwo: {
            flex: 1,

        },
        boxthree: {
            flex: 1,

        },
        box: {
            flexDirection: 'row',
            position: 'relative',
            marginBottom: 10,


        },
        signUpText: {
            fontSize: 20,
            justifyContent: 'center',


            color: 'white',
            alignSelf: 'center',
        },
        opencancel: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },
        opensave: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },
    });