/*
FileName:AdminChat.js
Version:1.0.0
Purpose:Getting the List of all the employees list and Chat 
Developers:Mahesh Reddy
*/
import React, { Component } from 'react';
import { Platform, Linking, Image, StyleSheet, Text, FlatList, TouchableOpacity, Picker, View, StatusBar, Dimensions, Alert } from 'react-native';
import { Title, Button, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, Subtitle, Item, Input, FooterTab } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import AsyncStorage from '@react-native-community/async-storage';
import Icon from 'react-native-vector-icons/FontAwesome';
import Communications from 'react-native-communications';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import Toast from 'react-native-whc-toast';
import DropDownPicker from 'react-native-dropdown-picker';
import ModalSelector from 'react-native-modal-selector';
// import { Dropdown } from 'react-native-material-dropdown';
import { SwipeListView } from 'react-native-swipe-list-view';
import { NavigationEvents } from 'react-navigation';
import jwt_decode from "jwt-decode";
import Main from '../Maintenance/Main';
const check = new Main()
import UserDatabase from '../OfflineDB/UserDatabase';
import { MANAGEEMPLOYEES, EMAIL, MOBILE, CONTACT, EMAILUSERNAME, ADDEMPLOYEE } from '../CommonComponents/Header';

const db = new UserDatabase();
import {
    BallIndicator,
    BarIndicator,
    DotIndicator,
    MaterialIndicator,
    PacmanIndicator,
    PulseIndicator,
    SkypeIndicator,
    UIActivityIndicator
} from 'react-native-indicators';

class ListItem extends Component {

    constructor(props) {
        super(props);
        this.state = {
            // isLoading: true,
            dataSource: [],
            dataSource2: [],
            roledata: '',
            sendBy: '',
            // expanded: false,
        }

        this.getMessages();
    }
    getMessages() {
        log("Info", " getMessages(role, userToken, cropcode) is used getting task related messages");
        // const groupId = this.state.subtaskId;
        // console.warn("getmessages");
        // alert("Hello")
        AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            this.setState({ userid: userToken });
            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;
                // console.warn("userToken"+userToken)
                // console.warn("cropcode"+cropcode)

                NetInfo.fetch().then(state => {
                    if (state.type == "none") {
                        log("Warn", "No internet connection");
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    }
                    else {
                        fetch(API + "squad_chat.php",
                            {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({

                                    action: "get_all_messages",
                                    corp_code: cropcode,
                                    sendBy: userToken,
                                    // projectId: projectId,


                                })
                            })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                console.warn("Messages For chat application" + JSON.stringify(responseJson.data));
                                // alert(JSON.stringify(responseJson))
                                // console.warn("Messages from users" + JSON.stringify(responseJson))
                                // console.warn("Send By Name" + JSON.stringify(responseJson.data))
                                if (responseJson.status === 'True') {

                                    console.warn("Setted Data")



                                    this.setState({
                                        dataSource2: responseJson.data,
                                    });
                                    console.warn("Method data" + responseJson.data.sendBy)
                                }
                                else {
                                    console.warn("Empty  Data")
                                    this.setState({
                                        dataSource: '',
                                    });
                                }
                            })
                            .catch((error) => {
                                console.error(error);
                                log("Error", "getting task related messages error");
                            });

                    }
                });
            });
        });
    }

    //Navigates to AdminChatUser Screen
    AdminChatUser(taskid, action, msgCount) {
        // console.warn("msgCount" + msgCount);
        // console.warn("taskid" + taskid);
        log("Info", "UserPendingMyTasks:AdminChatUser(item, index) used to navigate to taskchat")
        this.props.navigation.navigate("AdminChatUser", { id: taskid, action: "maintask", sno: msgCount });
    }


    render() {



        const { item } = this.props;
        const { emp_role } = this.props;
        // alert(emp_role)


        let button1;
        // if (this.state.emp_role === "Emp" || "Manager" || "Approver") {
        button1 = <TouchableOpacity style={{ marginTop: 12 }}
            onPress={() => this.props.navigation.navigate("UserChat", {
                empId: item.id,
                // action:"send"
                name: item.name,
                device_id: item.device_id,
                // mobile: item.mobileNumber,
                // email: item.email,
                // designation: item.designation,
                // userName: item.userName,
                // team: item.team,
                // empStatus: item.empStatus,
                // workingStatus: item.workingStatus,
                // role: item.role
            })}>
            <Icon name="comments" style={{ color: '#808080', paddingRight: 5 }} size={25} />
        </TouchableOpacity>


        // var data1=this.state.dataSource1;
        const getMessagesCount = (data1, id) => {
            //  console.warn("ids"+JSON.stringify(data1) +id)
            // alert(id)

            //  var msg=this.state.dataSource1;
            // console.warn("Datasource and id send by"+JSON.stringify(data1.sendBy))
            let msgCount = data1.filter(message => message.sendBy === id).map((messages, i) => {
                return i,messages

            })

            // console.warn("iiiiiiii" + msgCount)

            return (
                // console.warn("iiiiiiii" + msgCount),
                <View>
                    <Text style={{ color: 'red', }}> {msgCount.length > 0 ? msgCount.length : null} </Text>
                    {/* {msgCount.length > 0 ? msgCount.length : null} */}
                    {
                        msgCount.length > 0 ?

                            <Icon name="comments" style={{ color: '#808080', paddingRight: 5 }} size={25} onPress={() => this.props.navigation.navigate("AdminChatUser", {
                                empId: item.id,
                                name: item.name,
                                device_id: item.device_id,
                                sno: msgCount,


                            })} />
                            //     <TouchableOpacity style={{ marginTop: -20, marginLeft: 18 }} onPress={() => { this.AdminChatUser(id, "maintask", msgCount) }}>
                            //     <Image style={{ width: 25, height: 25 }} source={require('../Images/chat.png')} />
                            //   </TouchableOpacity>

                            :
                            <Icon name="comments" style={{ color: '#808080', paddingRight: 5 }} size={25} onPress={() => this.props.navigation.navigate("AdminChatUser", {
                                empId: item.id,
                                name: item.name,
                                device_id: item.device_id,
                                sno: msgCount,


                            })} />
                        //     <TouchableOpacity style={{ marginTop: -20, marginLeft: 18 }} onPress={() => { this.AdminChatUser(id, "maintask", msgCount) }}>
                        //     <Image style={{ width: 25, height: 25 }} source={require('../Images/chat.png')} />
                        //   </TouchableOpacity>


                    }

                </View>
            )

        }


        // const getMessagesCount = ( msg, empId) => {
        //     //  console.warn("ids"+JSON.stringify(data1) +id)
      
        //     //  var msg=this.state.dataSource1;
        //     // console.warn("Datasource and id send by"+JSON.stringify(data1.sendBy))
        //     const msgCount = msg.filter(message => message.sendBy === empId).map((messages, i)=> {
      
        //       return i, messages
      
        //     })
      
        //     // console.warn("iiiiiiii" + id)
        //     console.warn("msgcount" + msgCount)
        //     // alert("msgcount" + msgCount)
      
        //     return (
        //       // console.warn("iiiiiiii" + msgCount),
        //       <View>
        //         <Text style={{ color: 'green', paddingTop: -20, marginRight: 10 }}> {msgCount.length > 0 ? msgCount.length : null} </Text>
        //         {/* {msgCount.length > 0 ? msgCount.length : null} */}
        //         {
        //           msgCount.length > 0 ?
      
        //             <TouchableOpacity style={{ marginTop: -20, marginLeft: 10 }} onPress={() => { this.AdminChatUser( "UserChat", msgCount) }}>
        //               <Image style={{ width: 25, height: 25 }} source={require('../Images/chat.png')} />
        //             </TouchableOpacity>
        //             :
        //             <TouchableOpacity style={{ marginTop: -20, marginLeft: 10 }} onPress={() => { this.AdminChatUser( "UserChat", msgCount) }}>
        //               <Image style={{ width: 25, height: 25, }} source={require('../Images/chat.png')} />
      
        //             </TouchableOpacity>
      
        //         }
      
        //       </View>
        //     )
      
        //   }
      
      

        return (

            <View style={styles.container}>
                <View style={styles.signup}>
                    <View style={[styles.buttonContainer, styles.signupButton]} >
                        <View style={styles.box}>
                            <View style={{ flexDirection: 'row' }}>
                                <Text style={styles.signUpText1} >{item.name}</Text>
                            </View>
                            <View style={{ flexDirection: 'row', justifyContent: 'flex-end', alignItems: 'center' }}>
                                {/* {getMessagesCount(this.state.dataSource2, item.id)} */}
                               { getMessagesCount( this.state.dataSource2,item.id)}
                            </View>
                        </View>
                    </View>


                    {/* <View
                        style={{
                            marginTop: 15,
                            borderBottomColor: '#C0C0C0',
                            borderBottomWidth: 0.2,
                        }}
                    /> */}
                </View>


            </View>
        )
    }
}
export default class AdminChat extends Component {
    // static navigationOptions = () => {
    //   return {
    //     tabBarOnPress({ navigation, defaultHandler }) {
    //       navigation.state.params.onTabFocus();
    //       defaultHandler();
    //       this.onRefresh();
    //     }
    //   };
    // }


    constructor(props) {
        super(props);
        props.navigation.setParams({
            onTabFocus: this.handleTabFocus
        });
        let button;
        this.state = {
            isLoading: true,
            dataSource: [],
            dataSource1: [],
            isFetching: false,
            result: '',
            emp_role: '',
            squadName: '',


        }
        AsyncStorage.getItem("cropcode", (err, res) => {
            this.setState({ squadName: res });
            console.warn("squadname" + this.state.squadName);
        });
        this.arrayholder = [];
        this.button = button;


    }
    // handleTabFocus = () => {
    //   this.onRefresh();
    // };

    componentDidMount() {
        log("Debug", "Employees list getting screen is loaded at user side");
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
                this.getManageEmployeesList(); //For Getting ManageEmployeesList from offline
                this.getAgileProjects();
            } else {
                //to get the lsit of list of employees
                this.UserManageEmployees()
                // this.GetStatus();
                // this.getMessages();
            }
        });

        AsyncStorage.getItem("emp_role", (err, res) => {
            console.log(res)
            const emp_role1 = res;
            this.setState({ emp_role: emp_role1 })
        })
        AsyncStorage.getItem("userToken", (err, res) => {
            console.warn("empId" + res)
            const userToken = res;
            this.setState({ userToken: userToken })
        })
    }

    //For store Agile projects for offline Start
    addAgileProjects(data) {
        console.warn("hello naveen" + JSON.stringify(data));
        db.addAgileProjects(data).then((result) => {
            console.log(result);
        }).catch((err) => {
            console.log(err);
        })
    }
    //For store Agile projects for offline End
    //For Getting offline Project List Start
    getAgileProjects() {
        db.getAgileProjects().then((data) => {
            console.warn("AgileProjectsList" + JSON.stringify(data))
            this.setState({
                data2: data,
            });
        }).catch((err) => {
        })
    }
    //For Getting offline Project List End

    //to refresh the data
    onRefresh() {
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
                this.getManageEmployeesList(); //For Getting ManageEmployeesList from offline
            } else {
                //to get the lsit of list of employees
                this.UserManageEmployees()
                // this.getMessages();
            }
        });

    }

    //get project list dropdown data


    //get project list dropdown data
    GetStatus() {
        log("Info", "UserProfile:GetStatus() method is used to get status of employee");
        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    // console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                    this.getAgileProjects();
                } else {

                    fetch(API + 'squads.php', {
                        method: 'POST',
                        headers: {
                            Accept: 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({

                            empId: empId,
                            action: 'get_squads',

                        })
                    })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            console.warn(responseJson)
                            // alert(JSON.stringify(responseJson.data))
                            if (responseJson.status == 'True') {
                                // this.setState({
                                //     isLoading: false,
                                //     dataSource1: [...responseJson.data],
                                // }, function () {
                                //     // In this block you can do something with new state.
                                // });
                                console.log("Testing" + JSON.stringify(responseJson.data))
                                const data2 = [];
                                this.addAgileProjects(responseJson.data) //Project list store in offline
                                responseJson.data.map(x => {
                                    data2.push({ label: x.value, value: x.value })
                                })
                                this.setState({
                                    data2: data2,
                                })
                                console.warn("Hello" + JSON.stringify(data2))

                                // this.setState({
                                //     data2: responseJson.data
                                // });
                                console.warn(this.state.data2);
                            } else {
                                log("Warn", "status of employee is not available");
                            }
                        })
                        .catch((error) => {
                            console.error(error);
                            log("Error", "error in  getting status of employee");
                        });
                }
            });
        });

    }
    // Update Status of Employee
    UpdateStatus(squadName) {
        // const { squadName } = this.state;
        log("Info", "UserProfile:UpdateStatus(status) method is used to update status of employee");
        console.warn("project" + JSON.stringify(squadName));

        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            console.log(res);

            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;

                // console.log(cropcode);
                NetInfo.fetch().then(state => {
                    if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                        console.log(state.type);
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                        //for offline project switching start
                        this.setState({
                            squadName: squadName
                        });
                        AsyncStorage.setItem('cropcode', squadName);
                        this.getManageEmployeesList(); //For Getting ManageEmployeesList from offline
                        //for offline project switching end
                    } else {

                        fetch(API + 'squad_login.php', {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                username: empId,
                                corp: squadName,
                                projectId: projectId

                            })
                        })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                console.warn(JSON.stringify(responseJson))

                                if (responseJson.status == 'TRUE') {
                                    AsyncStorage.setItem('auth', responseJson.jwt) //store the token information  with exp
                                    const tokenDetails = jwt_decode(responseJson.jwt);
                                    console.log(tokenDetails.data)
                                    AsyncStorage.setItem('roleCount', tokenDetails.data.roleCount)
                                    // dispatch(setCurrentUser(tokenDetails.data)); //store the user information
                                    AsyncStorage.setItem('status', tokenDetails.data.empStatus)


                                    AsyncStorage.setItem('userToken', tokenDetails.data.empId);
                                    AsyncStorage.setItem('userName', tokenDetails.data.userName);
                                    AsyncStorage.setItem('emp_role', tokenDetails.data.role);
                                    AsyncStorage.setItem('cropcode', tokenDetails.data.corp);
                                    AsyncStorage.setItem('projectId', tokenDetails.data.projectId);
                                    // this.props.navigation.navigate('UserProfile');
                                    // console.warn("HI" + empstatus)
                                    this.setState({

                                        squadName: tokenDetails.data.corp,

                                    });
                                    this.UserManageEmployees();
                                    //  alert("Project Changed Successfully")


                                } else {
                                    //    alert("user already exist");
                                    log("Warn", "status of employee is not able to update");
                                }

                            })
                            .catch((error) => {
                                console.warn(error);
                                log("Error", "error in updating status of employee");
                            });
                    }
                });
            });
        });

    }

    //For getManageEmployeesList from offline
    getManageEmployeesList() {
        AsyncStorage.getItem("cropcode", (err, res) => {
            const projectName = res;
            db.getManageEmployeesList(projectName).then((data) => {
                console.warn("ManageEmployeesList" + JSON.stringify(data))
                this.setState({
                    dataSource: data,
                    isLoading: false,
                });
                this.arrayholder = data;
            }).catch((err) => {
                console.log(err);
                this.setState = {
                    isLoading: false
                }
            })
        })
    }
    //For getManageEmployeesList from offline

    //For store ManageEmployeesList from offline
    addManageEmployeesList(data, cropcode) {
        console.warn("hello" + JSON.stringify(data));
        db.addManageEmployeesList(data, cropcode).then((result) => {
            this.setState({
                isLoading: false,
            });
        }).catch((err) => {
            console.log(err);
            this.setState({
                isLoading: false,
            });
        })
    }
    // componentWillReceiveProps(nextProps) {
    //   //to get the lsit of list of employees
    //   this.UserManageEmployees();
    // }

    //to get the lsit of list of employees
    UserManageEmployees() {
        log("Info", "UserManageEmployees:getEmployeeList() method is used to get employee list");
        AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;
            //   alert(cropcode)

            AsyncStorage.getItem("empId", (err, res) => {
                const empId = res;
                AsyncStorage.getItem("userName", (err, res) => {
                    const userName = res;

                    // alert(userName)
                    AsyncStorage.getItem("emp_role", (err, res) => {
                        const emp_role = res;
                        //Checking the Internet Connection
                        NetInfo.fetch().then(state => {
                            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {

                                Snackbar.show({
                                    title: 'No Internet Connection',
                                    backgroundColor: 'red',
                                    duration: Snackbar.LENGTH_LONG,
                                });
                            } else {

                                fetch(API + 'squad_chat.php',
                                    {
                                        method: 'POST',
                                        headers: {
                                            Accept: 'application/json',
                                            'Content-Type': 'application/json',
                                        },
                                        body: JSON.stringify({
                                            crop: cropcode,
                                            //   projectId: projectId,
                                            action: "get_all_employees",
                                            // userType: emp_role,
                                            // empId: empId
                                        })
                                    })
                                    .then((response) => response.json())

                                    // console.warn(responseJson.data)


                                    .then((responseJson) => {
                                        // alert(JSON.stringify(responseJson))
                                        // console.warn("Employees" + JSON.stringify(responseJson));
                                        this.addManageEmployeesList(responseJson.data, cropcode) //Store Manage Employee List in Offline 

                                        //     this.setState({
                                        //         isLoading: false,
                                        //         dataSource: responseJson.data,
                                        //         isFetching: false
                                        //     }, function () {
                                        //     });

                                        //     this.arrayholder = responseJson.data;

                                        // })
                                        var employee = [];
                                        responseJson.data.map((x) => {
                                            return (x.email !== userName ? employee.push(x) : null);
                                        })

                                        this.setState({
                                            isLoading: false,
                                            dataSource: employee,
                                            isFetching: false
                                        },
                                            function () {

                                            }
                                        );

                                        this.arrayholder = responseJson.data;
                                    })
                                    .catch((error) => {
                                        check.Maintenance();
                                        console.error(error);
                                        log("Error", "error in getting employee list at user side");
                                    });

                            }
                        });

                    });
                });

            });

        });
    }


    //Seperate the List date
    FlatListItemSeparator = () => {
        return (
            <View
                style={{
                    //  height: .5,
                    width: "100%",
                    backgroundColor: "#000",
                }}
            />
        );
    }
    //For Empty list
    _listEmptyComponent = () => {
        return (
            <View>
                <Text></Text>

            </View>
        )
    }

    //to filter the search data in search area 
    SearchFilterFunction(text) {
        log("Info", "UserManageEmployees:SearchFilterFunction(text) method is used for search functionality")
        const newData = this.arrayholder.filter(function (item) {

            const name = item.name.toUpperCase()
            const name1 = text.toUpperCase()
            const empStatus = item.empStatus.toUpperCase()
            const empStatus1 = text.toUpperCase()
            //const designation = item.designation.toUpperCase()
            // const designation1 = text.toUpperCase()
            const email = item.email.toUpperCase()
            const email1 = text.toUpperCase()
            const mobileNumber = item.mobileNumber.toUpperCase()
            const mobileNumber1 = text.toUpperCase()

            return name.indexOf(name1) > -1 ||
                //  date.indexOf(date1) > -1 || 
                empStatus.indexOf(empStatus1) > -1 ||
                //designation.indexOf(designation1) > -1 ||
                email.indexOf(email1) > -1 ||
                mobileNumber.indexOf(mobileNumber1) > -1
        })
        this.setState({
            dataSource: newData,
            text: text
        })
    }






    render() {
        // alert(this.state.dataSource)
        let button;
        if (this.state.emp_role === "Emp") {
            button = null;
        } else {
            button =
                <TouchableOpacity style={{ marginTop: 12 }}
                    onPress={(item) => this.props.navigation.navigate("UserManageEmployeesTasks", {
                        empId: item.id,
                        name: item.name,
                        mobile: item.mobileNumber,
                        email: item.email,
                        designation: item.designation,
                        userName: item.userName,
                        team: item.team,
                        empStatus: item.empStatus,
                        workingStatus: item.workingStatus,
                        role: item.role
                    })}>
                    <Icon name="chevron-right" style={{ color: '#808080', paddingRight: 5 }} size={15} />
                </TouchableOpacity>
        }

        if (this.state.isLoading) {
            return (
                <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                    <DotIndicator color='#00A2C1' />
                </View>
            );

        }

        return (
            <Container style={{ height: Dimensions.get('window').height }}>
                {/* <NavigationEvents
          onDidFocus={() => this.onRefresh()}
        /> */}

                <Header
                    androidStatusBarColor="#00A2C1"
                    style={{
                        backgroundColor: '#00A2C1',
                        height: 60,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>
                   <Left>
                        <Icon name="arrow-left" size={20} style={{ color: '#fff', }} onPress={() =>
                            this.props.navigation.push("UserDashboard")} />
                    </Left>
                    <Body style={{ paddingLeft: 30, }}>
                        <Title style={{ color: '#fff',  paddingTop: 20 }}>CHAT</Title>
                        <Subtitle></Subtitle>
                    </Body>

                </Header>
                <Item >

                    <Input placeholder="Search"
                        onChangeText={(text) => this.SearchFilterFunction(text)} />
                    <Icon style={{ marginRight: 10, color: 'black' }} size={25} name="search" />
                </Item>
                <View style={{ height: '85%' }}>

                    <FlatList
                        extraData={this.state}
                        keyExtractor={this._keyExtractor}
                        renderItem={this._renderItem}
                        style={{ flex: 1, }}
                        data={this.state.dataSource}
                        onRefresh={() => this.onRefresh()}
                        refreshing={this.state.isFetching}
                        ItemSeparatorComponent={this.FlatListItemSeparator}
                        renderItem={({ item, index }) =>
                            <View style={styles.container2} >
                                <ListItem
                                    navigation={this.props.navigation}
                                    emp_role={this.state.emp_role}
                                    AdminChatUser={() => this.AdminChatUser(item, index)}//For TaskLevel Chat
                                    item={item}
                                //   deleteAction={() => this.deleteAction(item, index)}//delete action for employee
                                />
                            </View>
                        }
                        keyExtractor={item => item.id}
                        ListEmptyComponent={this._listEmptyComponent}
                    />

                    {/* <SwipeListView
            data={this.state.dataSource}
            onRefresh={() => this.onRefresh()}
            refreshing={this.state.isFetching}
            renderItem={(data) => (

              <View style={styles.container2} >
                <ListItem navigation={this.props.navigation}
                  data={data}
                  deleteAction={() => this.deleteAction(data, index)}//delete action for employee

                  emp_role={this.state.emp_role}

                />
              </View>

            )}

            renderHiddenItem={(data, rowMap) => (

              <View style={styles.rowBack}>

                <Text>{data.item.empStatus}</Text>
                <Text>{data.item.empStatus}</Text>
              </View>

            )}

            leftOpenValue={100}
            rightOpenValue={-100}

          /> */}
                    <View style={{ marginBottom: 5, }} />
                </View>

                {/* <View style={{ height: hp('10%') }}></View> */}


                {/* <View style={{ height: hp('10%') }}></View>
        <TouchableOpacity onPress={() => this.props.navigation.navigate("AddUser")} style={styles.bottomView}>

          <View style={styles.bottomView} >
            <Text style={styles.textStyle}>  {ADDEMPLOYEE}</Text>
          </View>
        </TouchableOpacity> */}

            </Container>
        );
    }
}
//Styles for UI
const styles = StyleSheet.create({
    container: {
        flex: 1,
        paddingTop: 15,
        backgroundColor: 'white',

        paddingRight: 20,
    },
    buttonContainer: {
        width: wp('95%'),
        alignSelf: 'baseline',
        marginBottom: 10,
        color: '#d2691e',
        //backgroundColor:'#fadbd8',
        marginLeft: 4,
    },
    signupButton: {


    },
    subcontainer: {
        flex: 2,
        flexDirection: 'row',

    },
    signUpText0: {
        fontSize: 15,

        paddingLeft: 20,
    },
    signUpText1: {
        fontSize: 16,

        paddingLeft: 10,
        fontWeight: 'bold'
    },

    signUpText00: {
        fontSize: 15,

        paddingLeft: 20,
    },
    signUpText11: {
        fontSize: 12,
        paddingTop: 10,

        color: 'black',
        paddingLeft: 10,
    },
    signUpText11email: {
        fontSize: 12,
        paddingTop: 10,

        color: 'black',
        paddingLeft: 10,
    },
    signUpText11mobile: {
        fontSize: 12,
        paddingTop: 10,
        //fontStyle: 'italic',
        color: 'black',
        paddingLeft: 10,
    },
    signUpText12: {
        fontSize: 15,
        paddingTop: 10,
        paddingBottom: 10,
        color: 'black',
        paddingLeft: 15,
    },

    signUpText000: {
        fontSize: 12,

        paddingBottom: 10,
        paddingLeft: 20,
    },
    signUpText111: {
        fontSize: 12,
        paddingBottom: 10,

        color: 'black',

        paddingLeft: -20,
    },
    end: {

        alignItems: 'flex-end',

    },
    end1: {
        flex: 1,

        justifyContent: 'space-between',

        flexDirection: 'row',
    },
    s: {
        justifyContent: 'center',

        // backgroundColor: '#ed7070',
        shadowOffset: { width: 50, height: 50 },
        alignItems: 'center',
        width: wp('40%'),
        height: hp('12%'),
        borderTopLeftRadius: 10,
        borderBottomLeftRadius: 10,

    },
    signUpText2: {
        fontSize: 15,
        paddingRight: 10,

        paddingLeft: 23,
        color: 'black',

        justifyContent: 'center',

    },
    signUpText02: {
        fontSize: 15,
        paddingRight: 10,

        paddingLeft: 23,
        color: 'red',
        paddingBottom: 10,

        justifyContent: 'center',

    },
    signUpText022: {
        fontSize: 15,

        paddingLeft: 23,
        color: 'green',
        paddingBottom: 10,

        justifyContent: 'center',

    },
    rowBack: {
        alignItems: 'center',
        backgroundColor: '#81def0',
        flex: 1,
        flexDirection: 'row',
        justifyContent: 'space-between',
        paddingLeft: 10,
    },
    rowFront: {
        alignItems: 'center',
        backgroundColor: '#81def0',
        flex: 1,
        flexDirection: 'row',
        justifyContent: 'space-between',
        paddingRight: 10,
    },
    signUpText002: {
        fontSize: 12,

        paddingLeft: 23,

        paddingBottom: 10,

        justifyContent: 'center',

    },
    signUpText0002: {
        fontSize: 13,
        paddingRight: 45,

        paddingLeft: 23,

        paddingBottom: 10,

        justifyContent: 'center',

    },
    signUpText3: {

        paddingBottom: 10,
        paddingLeft: 23,
        fontSize: 15,

        paddingRight: 13,

        alignItems: 'center',
    },
    signUpText4: {
        paddingBottom: 10,
        paddingLeft: 20,

        fontSize: 15,
        alignItems: 'center',
    },


    signUpText33: {

        paddingBottom: 10,
        paddingLeft: 23,
        fontSize: 12,

        paddingRight: 35,

        alignItems: 'center',
    },
    signUpText44: {
        paddingBottom: 10,
        paddingLeft: 20,

        paddingTop: -10,

        fontSize: 12,
        alignItems: 'center',
    },

    signup: {

        color: "#FFF",
    },
    boxone: {
        flex: 1,
        marginTop: 5,

    },
    boxtwo: {
        flex: 1,

    },
    boxthree: {
        flex: 1,

    },
    box: {
        justifyContent: 'space-between',
        flexDirection: 'row',
        position: 'relative',


    },
    bottomView: {
        flexDirection: 'row',
        justifyContent: 'center',
        position: 'absolute',
        height: FOOTER_MAX_HEIGHT,
        bottom: 0,
        left: 0,
        right: 0,
        backgroundColor: 'black',
        alignItems: 'center'
    },
    textStyle: {

        color: '#fff',
        paddingLeft: 5,
        paddingRight: 5,
        backgroundColor: '#00A2C1',
        fontSize: 22,
        marginLeft: 5,
        borderRadius: 5

    },
    signUpText: {
        fontSize: 20,
        justifyContent: 'center',


        color: 'white',
        alignSelf: 'center',
    },
    empstatusText: {
        fontSize: 12,
        paddingLeft: 23,
        paddingBottom: 10,
        justifyContent: 'center',
        // fontStyle: 'italic'

    },
    designationText: {
        fontSize: 12,
        paddingLeft: 23,
        paddingBottom: 10,
        //   fontWeight:'bold',
        justifyContent: 'center',

    },
});
const pickerSelectStyles = StyleSheet.create({
    inputIOS: {
        fontSize: 2,
        paddingVertical: 12,
        paddingHorizontal: 10,
        borderWidth: 1,
        borderColor: 'blue',
        borderRadius: 4,
        color: 'black',
        paddingRight: 30, // to ensure the text is never behind the icon
    },
    inputAndroid: {
        fontSize: 3,
        paddingHorizontal: 10,
        paddingVertical: 8,
        borderWidth: 0.5,
        borderColor: 'black',
        borderRadius: 8,
        color: 'black',
        paddingRight: 30, // to ensure the text is never behind the icon
        // backgroundColor:'pink'
    },
});