/*
FileName:UserChat.js
Version:1.0.0
Purpose:Getting the List of task messages with GroupName and List of Group Members and also send Message
Devloper:Naveen, Mahesh
*/

import React, { Component } from 'react';
import {
    StyleSheet,
    Text,
    View,
    TouchableOpacity,
    Image,
    Alert,
    ScrollView,
    TextInput,
    FlatList,
    Button,
    Dimensions,
    KeyboardAvoidingView,
    TouchableWithoutFeedback,
     Keyboard
} from 'react-native';
import Icon from 'react-native-vector-icons/FontAwesome';
import AsyncStorage from '@react-native-community/async-storage';

import { Title, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, Item, Input, FooterTab, Subtitle } from 'native-base';

import NetInfo from '@react-native-community/netinfo';
import { API } from "../WebServices/RestClient";
import log from '../LogFile/Log';


export default class UserChat extends Component {

    constructor(props) {
        super(props);
        this.state = {
            message: '',
            dataSource: [],
            subtaskId: this.props.navigation.state.params.taskid,
            action: this.props.navigation.state.params.action,
            empId: this.props.navigation.state.params.empId,
            device_id:this.props.navigation.state.params.device_id,
            name:this.props.navigation.state.params.name,

            userid: '',
            groupName: '',
            groupList: '',
        };
    }

    componentDidMount() {
        log("Debug", "Task Chat screen is loaded");
        // this.groupMembersList();//Getting the List of GroupMembers
        this.getMessages();//Getting the List of Messages based pn Task
        // this.userMessages();
        // this.sendMessageText();
        // alert(this.props.navigation.state.params.device_id)
    }
   
    //getting task related messages
    getMessages() {
        log("Info", " getMessages(role, userToken, cropcode) is used getting task related messages");
        // const groupId = this.state.subtaskId;

        AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            this.setState({ userid: userToken });
            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none") {
                    log("Warn", "No internet connection");
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                }
                else {
                    fetch(API + 'user_chat.php',
                        {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                // action: 'getMessages',
                                // corp_code: cropcode,
                                // empId:empId,
                                // groupId: groupId
                                // corp_code: cropcode,
                                // action: "getmessages",
                                // sendBy: userToken,
                                // receivedBy: this.props.navigation.state.params.empId
                                action: "get_messages",
                                //   groupId: groupId,
                                corp_code: cropcode,
                                // message: message,
                                sendBy: userToken,
                                // message: this.state.message,//uncomment this
                                receivedBy: this.props.navigation.state.params.empId,
                                projectId:projectId,
                                // messagedBy:userToken,//uncomment this

                            })
                        })
                        .then((response) => response.json())
                        .then((responseJson) => {

                            if (responseJson.status === 'True') {
                                console.warn(responseJson);
                                this.setState({
                                    dataSource: responseJson.data,
                                });
                            } else {
                                this.setState({
                                    dataSource: '',
                                });
                            }
                        })
                        .catch((error) => {
                            console.error(error);
                            log("Error", "getting task related messages error");
                        });

                }
            });
        });
        });
    }

    //getting task related messages
    userMessages() {
        log("Info", " getMessages(role, userToken, cropcode) is used getting task related messages");
        // const groupId = this.state.subtaskId;
        alert(this.props.navigation.state.params.empId)
        const message = this.state.message;
        AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            this.setState({ userid: userToken });
            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none") {
                    log("Warn", "No internet connection");
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                }
                else {
                    fetch(API + 'user_chat.php',
                        {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({

                                action: 'send',
                                //   groupId: groupId,
                                corp_code: cropcode,
                                message: message,
                                messagedBy: userToken,
                                message: this.state.message,
                                receivedBy: this.props.navigation.state.params.empId,
                                projectId:projectId,

                            })
                        })
                        .then((response) => response.json())
                        .then((responseJson) => {

                            if (responseJson.status === 'True') {
                                console.warn(responseJson);
                                this.setState({
                                    dataSource: responseJson.data,
                                });
                            } else {
                                this.setState({
                                    dataSource: '',
                                });
                            }
                        })
                        .catch((error) => {
                            console.error(error);
                            log("Error", "getting task related messages error");
                        });

                }
            });
            });
        });
    }
    //Sending Message without empty data added by naveen on 11 Nov
    sendMessageText() {
        if (this.state.message == 0) {
            alert("please type message")
            log("Warn", "message should not be empty");
        }
        else {
            this.sendMessage()
        }
    }
    //send messages
    sendMessage() {
        log("Info", " sendMessage(role, userToken, cropcode) is used to send messages");
        const message = this.state.message;
        // const groupId = this.state.subtaskId;
        // alert(this.props.navigation.state.params.device_id)
      console.warn(message)
        AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;
            fetch(API + 'user_chat.php', {
                method: 'POST',
                headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                },
                body: JSON.stringify({

                    action: "send",
                    //   groupId: groupId,
                    corp_code: cropcode,
                    // message: message,
                    sendBy: userToken,
                    message: this.state.message,
                    receivedBy: this.props.navigation.state.params.empId,
                    messagedBy:userToken,
                    projectId:projectId,
                    device_id:this.props.navigation.state.params.device_id,

                })
            }).then((response) => response.json())
                .then((responseJson) => {
                    this.getMessages();
                    this.setState({
                        message: ''
                    });
                    //message:this.state.message=''
                }).catch((error) => {
                    console.error(error);
                    log("Error", "send message error");
                });
            });
        });
    }

    renderDate = (date) => {
        return (
            <Text style={styles.time}>
                {date}
            </Text>
        );
    }

    render() {

        return (

            <KeyboardAvoidingView
            behavior={Platform.OS === "ios" ? "padding" : "height"}
            style={styles.container}
          >
            <TouchableWithoutFeedback onPress={Keyboard.dismiss}>

            <Container>
                <Header
                    androidStatusBarColor="#00A2C1"
                    style={{
                        backgroundColor: '#00A2C1',
                        height: 60,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>

                    <Icon name="arrow-left" size={20} style={{ color: '#fff', paddingTop: 15 }}
                        onPress={() =>
                            this.props.navigation.goBack()} />
                    <Body style={{ paddingLeft: 30, }}>
                        <Title style={{ color: '#fff', fontWeight: '600', paddingTop: 10 }}>{this.props.navigation.state.params.name}</Title>
                        <Subtitle></Subtitle>
                    </Body>

                </Header>
                {/* <KeyboardAvoidingView> */}
                <View style={styles.container}>
                    <ScrollView ref="scrollView"
                        onContentSizeChange={(width, height) => this.refs.scrollView.scrollTo({ y: height })}>



                        <FlatList style={styles.list}


                            data={this.state.dataSource}
                            keyExtractor={(item) => {
                                return item.id;
                            }}
                            renderItem={(message) => {
                                const item = message.item;
                                let inMessage = item.messagedBy === this.state.userid;
                                let itemStyle = !inMessage ? styles.itemIn : styles.itemOut;
                                const left = <Text style={{ fontSize: 12, color: 'orange' }}>{item.username}</Text>
                                const right = <Text style={{ fontSize: 12, color: 'blue' }}>{item.username}</Text>
                                return (
                                    <ScrollView>
                                    <View style={[styles.item, itemStyle]}>
                                        <View style={{ paddingLeft: 5, }}>
                                            {itemStyle === styles.itemOut ? left : right}
                                            <Text>{item.message}</Text>
                                            {!inMessage && this.renderDate(item.date)}
                                            {inMessage && this.renderDate(item.date)}
                                        </View>
                                    </View>
                                    </ScrollView>
                                )
                            }} />
                    </ScrollView>



                    <View style={styles.footer}>
                        <View style={styles.inputContainer}>
                            <TextInput style={styles.inputs}
                                placeholder="Write a message..."
                                underlineColorAndroid='transparent'
                                multiline={true}

                                onChangeText={(value) => this.setState({ message: value })}
                                value={this.state.message} />
                        </View>

                        <TouchableOpacity style={styles.btnSend} onPress={() => { this.sendMessageText() }}>
                            {/* <Image source={{uri:"https://png.icons8.com/small/75/ffffff/filled-sent.png"}} style={styles.iconSend}  /> */}
                            <Image source={require('../Images/sent.png')} style={styles.iconSend} />
                        </TouchableOpacity>
                    </View>

                </View>
                {/* </KeyboardAvoidingView> */}
            </Container>

            </TouchableWithoutFeedback>
    </KeyboardAvoidingView>

        );
    }
}
//Styles fro UI
const styles = StyleSheet.create({
    container: {
        flex: 1
    },
    list: {
        paddingHorizontal: 17,
    },
    footer: {
        flexDirection: 'row',
        height: 60,
        backgroundColor: '#eeeeee',
        paddingHorizontal: 10,
        padding: 5,
    },
    btnSend: {
        backgroundColor: "#00BFFF",
        width: 40,
        height: 40,
        borderRadius: 360,
        alignItems: 'center',
        justifyContent: 'center',
    },
    iconSend: {
        width: 30,
        height: 30,
        alignSelf: 'center',
    },
    inputContainer: {
        borderBottomColor: '#F5FCFF',
        backgroundColor: '#FFFFFF',
        borderRadius: 30,
        borderBottomWidth: 1,
        height: 40,
        flexDirection: 'row',
        alignItems: 'center',
        flex: 1,
        marginRight: 10,
        alignItems: 'baseline',

    },
    inputs: {
        height: 40,
        marginLeft: 16,
        borderBottomColor: '#FFFFFF',
        flex: 1,
        // position:'absolute',
        alignItems: 'baseline',
        paddingTop:10
    },
    balloon: {
        maxWidth: 200,
        padding: 10,
        borderRadius: 20,
    },
    itemIn: {

        alignSelf: 'flex-start',
        maxWidth: '98%',
        //  flexDirection:'row'
    },
    itemOut: {
        alignSelf: 'flex-end',
        //paddingLeft:10,
        maxWidth: '98%',
        // flexDirection:'row'
    },
    time: {
        alignSelf: 'flex-end',
        // margin: 15,
        fontSize: 12,
        color: "#808080",
        paddingRight: 10
    },
    item: {
        marginVertical: 14,
        flex: 1,
        flexDirection: 'row',
        // paddingLeft:50,
        backgroundColor: "#eeeeee",
        borderRadius: 10,
        padding: 5,
    },
});