import SQLite from "react-native-sqlite-storage";
SQLite.DEBUG(true);
SQLite.enablePromise(true);
const database_name = "Reactoffline.db";
const database_version = "1.0";
const database_displayname = "SQLite React Offline Database";
const database_size = 200000;

export default class ManageTasksPendingOffline {
    //Create or Initialize the DB and PendingManageTasks Table or Open DataBase
    initDB() {
        let db;
        return new Promise((resolve) => {
            // console.warn("Plugin integrity check ...");
            SQLite.echoTest()
                .then(() => {
                    // console.warn("Integrity check passed ...");
                    console.log("Opening database ...");
                    SQLite.openDatabase(
                        database_name,
                        database_version,
                        database_displayname,
                        database_size
                    )
                        .then(DB => {
                            db = DB;
                            // console.warn("Database OPEN");
                            db.executeSql('SELECT 1 FROM manageTasksPending LIMIT 1').then(() => {
                                // console.warn("Database is ready ... executing query ...");
                            }).catch((error) => {
                                // console.warn("Received error: ", error);
                                console.log("Database not yet ready ... populating data");
                                db.transaction((tx) => {
                                    tx.executeSql('CREATE TABLE IF NOT EXISTS manageTasksPending (projectitle,ideano,taskid,' +
                                        'taskStatus,tasktitle,taskdescription,assignby,assigntto,taskStatusDesc,assignedon,' +
                                        'taskEndDate,completeStatus,createdon,moduleId,targettime,assignedTo,cDate,' +
                                        'timeLeft,ptime,count)');
                                }).then(() => {
                                    console.log("Table created successfully");
                                }).catch(error => {
                                    console.log(error);
                                });
                            });
                            resolve(db);
                        })
                        .catch(error => {
                            console.warn(error);
                        });
                })
                .catch(error => {
                    console.warn("echoTest failed - plugin not functional");
                });
        });
    };

    //Close DataBase
    closeDatabase(db) {
        if (db) {
            console.log("Closing DB");
            db.close()
                .then(status => {
                    console.log("Database CLOSED");
                })
                .catch(error => {
                    this.errorCB(error);
                });
        } else {
            console.log("Database was not OPENED");
        }
    };

    //Store ManagetasksPending List
    addPendingManagetasksOffline(pending) {
        //   console.warn(profile.empid)
        let array = pending
        this.deletePendingManageTaskOffline();
        return new Promise((resolve) => {
            this.initDB().then((db) => {
                db.transaction((tx) => {
                    // console.warn(profile.empStatus)
                    array.forEach(pending => {
                        // console.warn(pending.subTaskId)
                    tx.executeSql('INSERT INTO manageTasksPending VALUES (?, ?, ?, ?, ? ,?, ?, ? ,?, ?, ?, ?, ?, ? ,?, ?, ? ,?, ?, ?)', [
                        pending.projectitle,pending.ideano,pending.taskid,pending.taskStatus,pending.tasktitle,pending.taskdescription,
                        pending.assignby,pending.assigntto,pending.taskStatusDesc,pending.assignedon,pending.taskEndDate,
                        pending.completeStatus,pending.createdon,pending.moduleId,pending.targettime,pending.assignedTo,pending.cDate,
                        pending.timeLeft,pending.ptime,pending.count
                    ]).then(([tx, results]) => {
                        resolve(results);
                        // console.warn("success")
                    });
                });
                }).then((result) => {
                    this.closeDatabase(db);
                }).catch((err) => {
                    console.warn("err" + JSON.stringify(err));
                });
            }).catch((err) => {
                console.warn("re" + err);
            });
        });
    }
    //Getting ManageTaskPendingList Details 
    pendingManageTasksListOffline() {
        console.warn("Query strated");
        return new Promise((resolve) => {
            const profile = [];
            this.initDB().then((db) => {
                db.transaction((tx) => {
                    tx.executeSql('SELECT * FROM manageTasksPending', []).then(([tx, results]) => {
                        console.warn("Query completed");
                        var len = results.rows.length;
                        for (let i = 0; i < len; i++) {
                            let row = results.rows.item(i);
                            const { projectitle,ideano,taskid,taskStatus,tasktitle,taskdescription,assignby,assigntto,taskStatusDesc,
                            assignedon,taskEndDate,completeStatus,createdon,moduleId,targettime,assignedTo,cDate,timeLeft,ptime,count} = row;
                            profile.push({
                                projectitle,ideano,taskid,taskStatus,tasktitle,taskdescription,assignby,assigntto,taskStatusDesc,assignedon,
                                taskEndDate,completeStatus,createdon,moduleId,targettime,assignedTo,cDate,timeLeft,ptime,count
                            });
                        }
                        // console.warn(profile)
                        resolve(profile);
                    });

                }).then((result) => {
                    this.closeDatabase(db);
                }).catch((err) => {
                    console.log(err);
                });
            }).catch((err) => {
                console.log(err);
            });
        });
    }

    //Delete PendingManageTasks 
        deletePendingManageTaskOffline() {
        return new Promise((resolve) => {
            this.initDB().then((db) => {
                db.transaction((tx) => {
                    tx.executeSql('DELETE FROM manageTasksPending', []).then(([tx, results]) => {
                        console.warn("deleted" + results);
                        resolve(results);
                    });
                }).then((result) => {
                    this.closeDatabase(db);
                }).catch((err) => {
                    console.log(err);
                });
            }).catch((err) => {
                console.log(err);
            });
        });
    }

}