/*
FileName:UserProfile.js
Version:1.0.4
Purpose:Edit and update the profile Description
Devloper:Mahesh
*/
import React, { Component } from 'react';
import { Platform, StyleSheet, TextPropTypes, Picker, Text, View, Image, StatusBar, Dimensions, TextInput, Alert, ScrollView } from 'react-native';
import { Icon, Title, Container, Content, Header, Right, Left, Body } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { TouchableOpacity } from 'react-native-gesture-handler';
// import Icon from 'react-native-vector-icons/FontAwesome';
import AsyncStorage from '@react-native-community/async-storage';
import { API,Client_URL } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import ModalSelector from 'react-native-modal-selector';
// import { Dropdown } from 'react-native-material-dropdown';
// import DropDownPicker from "react-native-custom-dropdown";
import DropDownPicker from 'react-native-dropdown-picker';
import RNPickerSelect from 'react-native-picker-select';
import log from '../LogFile/Log';
import UserDatabase from '../OfflineDB/UserDatabase';
const db = new UserDatabase();
import Main from '../Maintenance/Main';
const check = new Main()
import {
    BallIndicator,
    BarIndicator,
    DotIndicator,
    MaterialIndicator,
    PacmanIndicator,
    PulseIndicator,
    SkypeIndicator,
    UIActivityIndicator
} from 'react-native-indicators';


import { PROFILE, CHANGEPASSWORD, EMPLOYEEID, USERNAME, EMAIL, MOBILE, FULLNAME1, DESIGNATION, TEAM, ROLE, FMANAGER, RMANAGER, STATUS1 } from '../CommonComponents/Header';

export default class UserProfile extends Component {

    constructor(props) {
        super(props);

        this.state = {
            isLoading: false,
            profileInfo: [],
            data2: [],
            empstatus: '',
            city: null,
            mobile: '',
            dataSource: [],
            resource: [],
            itemA: null,
            // timeData:'',
            isVisibleA: false,

            itemB: null,
            isVisibleB: false
        }
    }
    changeVisibility(state) {
        this.setState({
            isVisibleA: false,
            isVisibleB: false,
            ...state
        });
    }


    componentDidMount() {
        log("Debug", "UserProfile screen is loaded");
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                // console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
                AsyncStorage.getItem("cropcode", (err, res) => {
                    const corpcode = res;
                    db.profileList(corpcode).then((data1) => {
                        // alert("data" + JSON.stringify(data1))
                        console.warn("Length" + data1.length)
                        if (data1.length == 0) {
                            // console.warn("Empty")
                        } else {
                            console.warn("Go" + data1[0].empid)
                            this.setState({
                                profileInfo: data1[0],
                                empstatus: data1[0].empStatus,
                                empid: data1[0].empid,
                                fullname: data1[0].fullName,
                                team: data1[0].team,
                                email: data1[0].email,
                                username: data1[0].username,
                                designation: data1[0].designation,
                                mobile: data1[0].mobile,
                                role: data1[0].role,
                                reportingManager: data1[0].reportingManager,
                                functionalManager: data1[0].functionalManager,
                            });
                        }
                    }).catch((err) => {
                        // console.warn("ERROR" + err);
                        this.setState({
                            isLoading: false
                        })
                    })
                });
            } else {
                this.profile();
                this.GetStatus();
                this.getShifts();
            }
        });
    }

    //validation For Mobile Number
    isValid() {
        const { mobile } = this.state;
        let valid = false;
        if (mobile.length === 0) {
            alert("Enter Mobile Number");
            log("Warn", "Mobile number should not be empty");
        }

        else if (mobile.length > 10) {
            alert("Enter Valid Number");
            log("Warn", "Mobile number should  be valid");
        }
        else if (mobile.length < 10) {
            alert("Enter Valid Number");
            log("Warn", "Mobile number should be valid");
        }
        else if (!this.mobilevalidate(mobile)) {
            alert('Invalid Phonenumber');

        }


        else {
            valid = true;
        }
        return valid;
    }
    mobilevalidate(mobile) {
        const reg = /^[0]?[6789]\d{9}$/;
        return reg.test(mobile);
    }

    //Getting the profile details of User
    // profile() {
    //     log("Info", "UserProfile:profile() method is used get employee profile data");
    //     AsyncStorage.getItem("cropcode", (err, res) => {
    //         const cropcode = res;

    //         AsyncStorage.getItem("empId", (err, res) => {
    //             const empId = res;
    //             NetInfo.fetch().then(state => {
    //                 if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
    //                     console.log(state.type);
    //                     Snackbar.show({
    //                         title: 'No Internet Connection',
    //                         backgroundColor: 'red',
    //                         duration: Snackbar.LENGTH_LONG,
    //                     });
    //                 } else {

    //                     fetch(API + 'getProfile.php', {
    //                         method: 'POST',
    //                         headers: {
    //                             'Accept': 'application/json',
    //                             'Content-Type': 'application/json',
    //                         },
    //                         body: JSON.stringify({
    //                             crop: cropcode,
    //                             action: "get",
    //                             //  userType: emp_role,
    //                             empId: empId
    //                         })
    //                     }).then((response) => response.json())
    //                         .then((responseJson) => {
    //                             console.log(responseJson);
    //                             console.log(JSON.stringify(responseJson))
    //                             console.log(JSON.stringify(responseJson))

    //                             //  this.profileData(responseJson.data[0])
    //                             db.addProfile(responseJson.data[0]).then((result) => {
    //                                 console.warn("hello" + JSON.stringify(result));
    //                             }).catch((err) => {
    //                                 console.warn("hello" + err);
    //                             })
    //                             this.setState({
    //                                 isLoading: false,
    //                                 profileInfo: responseJson.data[0],
    //                                 empstatus: responseJson.data[0].empStatus
    //                             },


    //                                 function () {

    //                                 });
    //                         }).catch((error) => {
    //                             check.Maintenance();
    //                             console.error(error);
    //                             log("Error", "Error in getting profile data");

    //                         });
    //                 }
    //             });
    //         });

    //     });
    // }

    //Getting the profile details of User
    profile() {
        // alert("profile")
        log("Info", "UserProfile:profile() method is used get employee profile data");
        AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;

            AsyncStorage.getItem("userToken", (err, res) => {
                const empId = res;

                AsyncStorage.getItem("projectId", (err, res) => {
                    const projectId = res;

                    NetInfo.fetch().then(state => {
                        if (state.type == "none") {
                            // console.log(state.type);
                            Snackbar.show({
                                title: 'No Internet Connection',
                                backgroundColor: 'red',
                                duration: Snackbar.LENGTH_LONG,
                            });
                        } else {

                            fetch(API + 'get_user.php', {
                                method: 'POST',
                                headers: {
                                    'Accept': 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({
                                    crop: cropcode,
                                    empId: empId,
                                    action: "get_user_profile",
                                    projectId: projectId
                                })
                            }).then((response) => response.json())
                                .then((responseJson) => {
                                    //alert(JSON.stringify(responseJson));
                                    console.log(JSON.stringify(responseJson))
                                    console.log(JSON.stringify("empInfo" + responseJson.data[0]))
                                    db.addProfile(responseJson.data, cropcode).then((result) => {
                                        console.warn("hello" + JSON.stringify(result));

                                    }).catch((err) => {
                                        console.warn("hello err" + err);
                                    })
                                    this.setState({
                                        isLoading: false,
                                        // empid: responseJson.data[0].empid,

                                        empid: responseJson.data[0].empid,
                                        fullname: responseJson.data[0].fullname,
                                        team: responseJson.data[0].team,
                                        email: responseJson.data[0].email,
                                        username: responseJson.data[0].username,
                                        designation: responseJson.data[0].designation,
                                        mobile: responseJson.data[0].mobile,
                                        role: responseJson.data[0].role,
                                        empstatus: responseJson.data[0].empStatus,
                                        shift_hours: responseJson.data[0].shift_hours,
                                        email_status: responseJson.data[0].email_status,
                                        free_licenses: responseJson.free_licenses,
                                        reportingManager: responseJson.data[0].reportingManager,
                                        functionalManager: responseJson.data[0].functionalManager,
                                    },


                                        function () {

                                        });
                                }).catch((error) => {
                                    check.Maintenance();
                                    console.error(error);
                                    log("Error", "Error in getting profile data");

                                });
                        }
                    });
                });
            });

        });
    }

    //Update the User Profile
    save() {
        log("Info", "UserProfile:save() method is used to update mobile number");
        const { mobile } = this.state;
        // console.log(mobile);
        if (this.isValid()) {

            AsyncStorage.getItem("userToken", (err, res) => {
                const empId = res;
                // console.log(res);


                AsyncStorage.getItem("cropcode", (err, res) => {
                    const cropcode = res;
                    // console.log(cropcode);
                    //alert(res + mobile);
                    NetInfo.fetch().then(state => {
                        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                            // console.log(state.type);
                            Snackbar.show({
                                title: 'No Internet Connection',
                                backgroundColor: 'red',
                                duration: Snackbar.LENGTH_LONG,
                            });
                        } else {

                            fetch(API + 'get_user.php', {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({
                                    action: 'update',
                                    // idea_id:idea_id, 
                                    corp: cropcode,
                                    // module_Name:modulename,
                                    number: mobile,
                                    empId: empId

                                })
                            })
                                .then((response) => response.json())
                                .then((responseJson) => {
                                    // console.log(responseJson)
                                    // console.warn(JSON.stringify(responseJson))
                                    if (responseJson.status == 'True') {
                                        alert("Updated Successfully")


                                    } else {
                                        // alert("user already exist");
                                        log("Warn", "user number already exist");
                                    }

                                })
                                .catch((error) => {
                                    console.error(error);
                                    log("Error", "Error in updating mobile number");
                                });
                        }
                    });
                });
            });
        }
    }
    //Verify the User Profile
    accountVerify() {
        log("Info", "UserManageEmployees:deleteEmployee() method is used to delete employee");
        AsyncStorage.multiGet(["cropcode", "userName"], (err, response) => {
            // const cropcode = response[0][1];
            // const userName = response[1][1];
            // alert(userName)
            // const crop = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {

                    fetch(API + 'get_user.php', {
                        method: 'POST',
                        headers: {
                            'Accept': 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({
                            action: 'account_verify',
                            username: userName,
                            url: Client_URL,

                        })
                    }).then((response) => response.json())
                        .then((responseJson) => {
                            console.log(JSON.stringify(responseJson));
                            console.log(responseJson);
                            alert(JSON.stringify(responseJson))

                            if (responseJson.status === 'True') {
                                // this.refs.toast.showCenter('Epic Squad is Deactivated', Toast.Duration.long, Toast.Position.center);
                                console.log("done")
                             
                                this.setState({ open: false })
                           
                            }
                            else {
                                // alert("Hello111");
                                // this.refs.toast.showCenter('Epic Squad is not Deactivated', Toast.Duration.long, Toast.Position.center);
                            }
                        }).catch((error) => {
                            console.error(error);
                            log("Error", "error in employee deletion");
                        });
                }
            });
        });
    };

    //get status dropdown data
    GetStatus() {
        log("Info", "UserProfile:GetStatus() method is used to get status of employee");
        AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    // console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {

                    fetch(API + 'user_status.php', {
                        method: 'POST',
                        headers: {
                            Accept: 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({
                            action: 'status',
                            corp: cropcode,


                        })
                    })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            console.log(responseJson)
                            // alert(JSON.stringify(responseJson));
                            if (responseJson.status == 'True') {
                                this.setState({
                                    isLoading: false,
                                    dataSource: [...responseJson.data],
                                }, function () {
                                    // In this block you can do something with new state.
                                });

                                // const data2 = [];

                                // responseJson.data.map(x => {
                                //     data2.push({ label: x.value, value: x.value })
                                // })
                                // this.setState({
                                //     data2: data2,
                                // })
                                // console.warn("Hello" + JSON.stringify(data2))

                                // this.setState({
                                //     data2: responseJson.data
                                // });
                                // console.warn(this.state.data2);
                            } else {
                                log("Warn", "status of employee is not available");
                            }
                        })
                        .catch((error) => {
                            console.error(error);
                            log("Error", "error in  getting status of employee");
                        });
                }
            });
        });

    }

    // Update Status of Employee
    UpdateStatus(empstatus) {
        log("Info", "UserProfile:UpdateStatus(status) method is used to update status of employee");
        console.warn("Hello" + empstatus);
        // alert(empstatus)

        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            console.log(res);


            AsyncStorage.getItem("cropcode", (err, res) => {
                const cropcode = res;
                console.log(cropcode);
                // alert(cropcode)
                NetInfo.fetch().then(state => {
                    if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                        console.log(state.type);
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    } else {

                        fetch(API + 'user_status.php', {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                action: 'update_status',
                                corp: cropcode,
                                status: empstatus,
                                empId: empId

                            })
                        })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                console.warn(JSON.stringify(responseJson))

                                if (responseJson.status == 'True') {
                                    console.warn("HI" + empstatus)
                                    this.setState({

                                        empstatus: empstatus
                                    });
                                    //  alert("Updated Successfully")


                                } else {
                                    //    alert("user already exist");
                                    log("Warn", "status of employee is not able to update");
                                }

                            })
                            .catch((error) => {
                                console.warn(error);
                                log("Error", "error in updating status of employee");
                            });
                    }
                });
            });
        });

    }

    //getting the Employees list for addind maintask
    getShifts() {
        log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");

        AsyncStorage.getItem("projectId", (err, res) => {
            const projectId = res;
            // alert(projectId)

            AsyncStorage.getItem("cropcode", (err, res) => {
                const cropcode = res;
                // alert(cropcode)
                NetInfo.fetch().then(state => {
                    if (state.type == "none") {
                        console.log(state.type);
                        log("Warn", "No internet connection");
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    } else {
                        fetch(API + 'get_user_shifts.php',
                            {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({

                                    action: "get_shifts",


                                })
                            })
                            .then((response) => response.json())

                            .then((responseJson) => {
                                // alert(JSON.stringify(responseJson))
                                if (responseJson.status === 'True') {
                                    console.warn("Sprints from active sprint board" + JSON.stringify(responseJson))
                                    // alert(JSON.stringify(responseJson))
                                    var sprintDetails = [];

                                    responseJson.data.map((sprints) => {

                                        return (
                                            sprintDetails.push({ 'key': sprints.ts_id, 'label': sprints.start_time + " - " + sprints.end_time + " " + sprints.time_zone })
                                        );
                                    })
                                    // this.addOfflineSprints(sprintDetails, cropcode)//Store Sprint List in Offline
                                    this.setState({
                                        resource: sprintDetails
                                    });
                                }
                            })
                            .catch((error) => {
                                console.error(error);
                                log("Error", "requested projects error");
                            });
                    }
                });
            });
        });
    }

    // Update Status of Employee
    UpdateStatus1(shift_id) {
        // alert(shift_id)
        // const { squadName } = this.state;
        log("Info", "UserProfile:UpdateStatus1(status) method is used to update status of employee");
        // console.warn("Hello" + squadName);

        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            console.log(res);

            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;



                // console.log(cropcode);
                NetInfo.fetch().then(state => {
                    if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                        console.log(state.type);
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                        //for offline project switching start
                        // this.setState({
                        //     timeData: timeData
                        // });
                        // AsyncStorage.setItem('cropcode', squadName);
                        // this.getOfflineSprints()//Getting the List of offline Sprints
                        // this.getOfflineActiveSprints("currentsprint") //Getting Current Sprint Backlogs in offline
                        //for offline project switching end
                    } else {

                        fetch(API + 'get_user_shifts.php', {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                emp_id: empId,
                                shift_id: shift_id,
                                action: "update_user_shift",


                            })
                        })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                // alert(JSON.stringify(responseJson))
                                console.warn(JSON.stringify(responseJson))

                                if (responseJson.status == 'True') {

                                    //alert("Working Hours changed")
                                    // this.props.navigation.navigate('UserProfile');
                                    // console.warn("HI" + empstatus)
                                    // this.setState({

                                    //     timeData: timeData
                                    // });
                                    //  alert("Project Changed Successfully")


                                } else {
                                    //    alert("user already exist");
                                    log("Warn", "status of employee is not able to update");
                                }

                            })
                            .catch((error) => {
                                console.warn(error);
                                log("Error", "error in updating status of employee");
                            });
                    }
                });
            });
        });

    }

    // Update Status of Employee end

    render() {
        if (this.state.isLoading) {
            return (
                <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                    <DotIndicator color='#00A2C1' />
                </View>
            );

        }
        let buttonL;
        if (this.state.free_licenses === "0") {
            buttonL =
                <View style={{ paddingTop: 50, paddingLeft: '40%', justifyContent: 'center', }}>
                    <TouchableOpacity onPress={() => this.props.navigation.navigate("AddLicenses", { username: this.state.username, fullName: this.state.fullname, email: this.state.email })} >
                        <Text style={{ backgroundColor: '#7CC82B', justifyContent: 'center', width: 80, height: 30, borderRadius: 10, textAlign: 'center', color: 'white', paddingTop: 5 }}>UPGRADE</Text>
                    </TouchableOpacity>
                </View>
        }
        else {
            buttonL =
                <View style={{ paddingTop: 50, paddingLeft: '40%', }}>
                    <TouchableOpacity onPress={() => this.props.navigation.navigate("AddLicensesPayment", { username: this.state.username, fullName: this.state.fullName, email: this.state.email })} >
                        <Text style={{ backgroundColor: '#7CC82B', justifyContent: 'center', width: 80, height: 30, borderRadius: 10, textAlign: 'center', color: 'white', paddingTop: 5 }}>UPGRADE</Text>
                    </TouchableOpacity>
                </View>
        }
        // alert(this.state.free_licenses)
        // let data2 = [{ value: 'commericial', }, { value: 'residencial', }];
        return (
            <Container>
                <Header
                    androidStatusBarColor="#00A2C1"
                    style={{
                        backgroundColor: '#00A2C1',
                        height: 60,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>
                    <Left>
                        <Icon name="md-menu" style={{ color: '#fff' }} onPress={() =>
                            this.props.navigation.toggleDrawer()} />
                    </Left>
                    <Body>
                        <Title style={{ color: '#fff', fontWeight: '600' }}>{PROFILE}</Title>
                    </Body>
                    <Right><Text style={{ color: 'white' }} onPress={() => this.props.navigation.navigate('UserPassword')}>{CHANGEPASSWORD}</Text></Right>

                </Header>
                <Content>

                    <View style={{ padding: 25 }}>
                        <View style={{ justifyContent: 'center', alignItems: 'center', height: hp('25%') }}>
                            <Image source={require('../Images/profile.jpeg')} style={{ width: wp('35%'), height: hp('20%'), margin: 10, borderRadius: 150 / 2, }} />
                            <Text >{this.state.fullname}</Text>
                            {/* <Text>FullName</Text> */}

                        </View>
                        <View style={{ paddingTop: 40, height: hp('50%') }}>
                            {/* <DropDownPicker
                        items={[
                            { label: 'Grand Total', value: 'item1', selected: true },
                            { label: 'Transport Charges', value: 'item2', selected: true },
                            { label: 'Commision', value: 'item2', selected: true },
                            { label: 'Grand Total', value: 'item1', selected: true },
                            { label: 'Transport Charges', value: 'item2', selected: true },
                            { label: 'Commision', value: 'item2', selected: true },
                        ]}
                        containerStyle={{ height: 40, width: 200, paddingLeft: 10 }}
                        style={{ backgroundColor: '#fafafa' }}
                        itemStyle={{
                            justifyContent: 'flex-start'
                        }}
                        dropDownStyle={{ backgroundColor: '#fafafa' }}

                    /> */}

                            {/* <DropDownPicker
    items={[
        {label: 'UK', value: 'uk'},
        {label: 'France', value: 'france'},
        {label: 'UK', value: 'uk'},
        {label: 'France', value: 'france'},
        {label: 'UK', value: 'uk'},
        {label: 'France', value: 'france'},
    ]}
    defaultValue={this.state.itemB}
    containerStyle={{height: 30,}}
 
    isVisible={this.state.isVisibleB}

    textInputStyle={{
        padding: 12,
        borderWidth: 1,
        borderColor: '#ccc',
        backgroundColor: '#FAF7F6',
      }}
      itemStyle={{
        padding: 10,
        marginTop: 2,
        backgroundColor: '#FAF9F8',
        borderColor: '#bbb',
        borderWidth: 1,
        // height:'10%'
      }}
      itemTextStyle={{

        color: '#222',
      }}
      itemsContainerStyle={{

        maxHeight: '100%',
        // alignSelf: 'baseline',
      }}
    onOpen={() => this.changeVisibility({
        isVisibleB: true
    })}
    onClose={() => this.setState({
        isVisibleB: false
    })}
    onChangeItem={item => this.setState({
        itemB: item.value
    })}
/> */}
                            <View style={{ flexDirection: 'row', }}>
                                <View style={{ paddingLeft: '2%', width: wp('32%') }}>
                                    <Text>{EMPLOYEEID}</Text>

                                </View>
                                <View>
                                    <Text>{this.state.empid}</Text>
                                </View>

                            </View>



                            <View style={{ flexDirection: 'row', paddingTop: 10, }}>
                                <View style={{ paddingLeft: '2%', width: wp('32%') }}>
                                    <Text>{USERNAME}</Text>

                                </View>
                                <View>

                                    <Text>{this.state.username}</Text>
                                </View>



                            </View>

                            <View style={{ flexDirection: 'row', paddingTop: 10, }}>
                                <View style={{ paddingLeft: '2%', width: wp('32%') }}>
                                    <Text>{FULLNAME1}</Text>

                                </View>
                                <View>

                                    <Text>{this.state.fullname}</Text>
                                </View>



                            </View>


                            <View style={{ flexDirection: 'row', paddingTop: 10, }}>
                                <View style={{ paddingLeft: '2%', width: wp('32%') }}>
                                    <Text>{EMAIL}</Text>

                                </View>
                                <View style={{ width: wp('60%') }}>
                                    <Text>{this.state.email}</Text>
                                </View>



                            </View>


                            {/* <View style={{ flexDirection: 'row', paddingTop: 10, }}>
                                <View style={{ paddingLeft: '2%', width: wp('30%') }}>
                                    <Text>{DESIGNATION}</Text>

                                </View>
                                <View>
                                    <Text>{this.state.designation}</Text>
                                </View>



                            </View> */}

                            {/* <View style={{ flexDirection: 'row', paddingTop: 10, }}>
                                <View style={{ paddingLeft: '2%', width: wp('30%') }}>
                                    <Text>{TEAM}</Text>

                                </View>
                                <View>
                                    <Text>{this.state.team}</Text>
                                </View>



                            </View> */}

                            <View style={{ flexDirection: 'row', paddingTop: 10, }}>
                                <View style={{ paddingLeft: '2%', width: wp('32%'), }}>
                                    <Text>{MOBILE}</Text>

                                </View>
                                <View>
                                    <Text>{this.state.mobile}</Text>

                                    {/* <TextInput
                                        maxLength={10}
                                        keyboardType='phone-pad'
                                        placeholder=''

                                        value={this.state.mobile}
                                    // onChangeText={(text) => this.setState({ mobile: text })}
                                    >
                                    </TextInput> */}

                                </View>



                            </View>

                            {/* <View style={{ flexDirection: 'row', }}>
                                <View style={{ paddingLeft: '2%', width: wp('35%') }}>
                                    <Text>{RMANAGER}</Text>

                                </View>
                                <View>
                                    <Text>{this.state.reportingManager}</Text>
                                </View>



                            </View> */}
                            {/* <View style={{ flexDirection: 'row', paddingTop: 10, }}>
                                <View style={{ paddingLeft: '2%', width: wp('35%') }}>
                                    <Text>{FMANAGER}</Text>

                                </View>
                                <View>
                                    <Text>{this.state.functionalManager}</Text>
                                </View>



                            </View> */}

                            {/* <View style={styles.role}>
                                <View style={{ paddingLeft: '2%', width: wp('30%') }}>
                                    <Text>{ROLE}</Text>

                                </View>
                                <View>
                                    <Text>{this.state.role}</Text>
                                </View>



                            </View> */}



                            <View style={{ flexDirection: 'row', paddingTop: 10, }}>
                                <View style={{ paddingLeft: '2%', width: wp('32%') }}>
                                    <Text>{ROLE}</Text>

                                </View>
                                <View>
                                    <Text>{this.state.role}</Text>
                                </View>



                            </View>

                            <View style={{ flexDirection: 'row', paddingTop: 10 }}>
                                <View style={{ paddingLeft: '2%', width: wp('32%') }}>
                                    <Text>{STATUS1}</Text>

                                </View>
                                <View>
                                    <Text>{this.state.empstatus}</Text>
                                </View>



                            </View>

                            <View style={{ flexDirection: 'row', paddingTop: 10 }}>
                                <View style={{ paddingLeft: '2%', width: wp('32%') }}>
                                    <Text>Working Hours</Text>

                                </View>
                                <View>
                                    <Text>{this.state.shift_hours}</Text>
                                </View>



                            </View>

                            <View style={{ flexDirection: 'row', paddingTop: 10 }}>
                                <View style={{ paddingLeft: '2%', width: wp('32%'),paddingTop:4 }}>
                                    <Text>Account Status</Text>

                                </View>
                                <View>
                                    {this.state.email_status === "1" ? <Text style={{color:'green'}}>Account Verified</Text> :
                                        <TouchableOpacity style={{height:30}} onPress={this.accountVerify()} >
                                            <Text style={styles.submit}>Verify</Text>
                                        </TouchableOpacity>}
                                </View>



                            </View>
                            <View>
                                {/* {buttonL} */}
                            </View>


                            {/* {this.state.free_licenses === 1 ? <Text>0</Text>:<Text>2</Text>} */}

                            {/* <View style={{ width: "100%", borderRadius: 20, height: 45, justifyContent: 'center', alignItems: 'center', flexDirection: 'row',marginTop:30,marginBottom:30 }}>


                                <ModalSelector
                                    style={{ width: "90%", backgroundColor: 'transparent', borderColor: 'black', borderWidth: 0.5, borderRadius: 20, }}
                                    data={this.state.resource}
                                    optionContainerStyle={{ backgroundColor: 'white' }}
                                    onChange={(itemValue) => {
                                        this.UpdateStatus1(itemValue.label),
                                            this.setState({
                                                // moduleId: itemValue.key,
                                                moduleDesc: itemValue.label,

                                            })
                                    }}

                                >

                                    <View style={{ width: 300, borderRadius: 20, height: 45, flexDirection: 'row', borderColor: 'black', }}>
                                        <Text style={{ marginTop: 5, color: 'black', width: 120, padding: 8 }}>Working Hours : </Text>

                                        <Text style={{ marginTop: 5, color: 'black', width: 200, padding: 8 }}>{this.state.moduleDesc}</Text>

                                        <Icon name="md-chevron-down-outline" size={25} style={{ color: 'white', marginTop: 5, }}
                                        />
                                    </View>

                                </ModalSelector>


                            </View>
                            <View style={{ width: "100%",justifyContent: 'center', alignItems: 'center',marginTop:10,marginBottom:30 }}>

                            <View style={{ width: "90%", backgroundColor: 'transparent', borderColor: 'black', borderWidth: 0.5, borderRadius: 20, }}>
                                <Picker
                                    selectedValue={this.state.empstatus}

                                    onValueChange={(itemValue, itemIndex) => this.UpdateStatus(itemValue)} >

                                    {this.state.dataSource.map((item, key) => (
                                        <Picker.Item label={item.value} value={item.value} key={key} />)
                                    )}

                                </Picker>
                            </View>
                            </View> */}

                            {/* <RNPickerSelect
                              placeholder={{
                                label: 'Select Status ',
                                value: null,
                                color: 'green',
                              }}
                                // style={pickerSelectStyles.inputAndroid}
                                value={this.state.empstatus}
                                onValueChange={(value) => { this.UpdateStatus(value) }}
                                items={this.state.data2}
                            /> */}
                        </View>
                        {/* <View style={{ paddingTop: 50, paddingLeft: '40%', justifyContent: 'center', }}>
                            <TouchableOpacity onPress={this.save.bind(this)} >
                                <Text style={styles.submit}>SUBMIT</Text>
                            </TouchableOpacity>
                        </View> */}





                    </View>
                    <Text style={styles.iosdropdown}></Text>

                </Content>

            </Container>
        );
    }
}

const styles = StyleSheet.create({
    submit: {
        flex: 1,
        ...Platform.select({
            ios: {
                color: 'white', paddingTop: 3, fontSize: 15, width: 100,
                height: 30, backgroundColor: '#00A2C1',
                textAlign: 'center', borderRadius: 10
            },
            android: {
                color: 'white', paddingTop: 3, fontSize: 15, width: 100,
                height: 30, backgroundColor: '#00A2C1',
                textAlign: 'center', borderRadius: 70
            },
        }),
    },
    iosdropdown: {
        flex: 1,
        ...Platform.select({
            ios: {
                marginTop: 200
            },
            android: {
                marginTop: 0
            },
        }),
    },
    mobile: {
        flex: 1,
        ...Platform.select({
            ios: {
                marginTop: 12
            },
            android: {

            },
        }),
    },
    role: {
        flex: 1,
        ...Platform.select({
            ios: {
                flexDirection: 'row', marginTop: 10
            },
            android: {
                flexDirection: 'row',
                paddingTop: 10,

            },
        }),
    },

});
const pickerSelectStyles = StyleSheet.create({
    inputIOS: {
        fontSize: 2,
        paddingVertical: 12,
        paddingHorizontal: 10,
        borderWidth: 1,
        borderColor: 'blue',
        borderRadius: 4,
        color: 'black',
        paddingRight: 30, // to ensure the text is never behind the icon
    },
    inputAndroid: {
        fontSize: 3,
        paddingHorizontal: 10,
        paddingVertical: 8,
        borderWidth: 0.5,
        borderColor: 'purple',
        borderRadius: 8,
        color: 'black',
        paddingRight: 30, // to ensure the text is never behind the icon
    },
});